clear all
clc

A = zeros(8,8);
A(1,1)= -0.69; A(1,2) =0.3;
A(2,1)=1.26; A(2,2)=-1.61; A(2,3)=0.59;
A(3,2)=1.02; A(3,3)=-1.31; A(3,4)=0.59;
A(4,3)=0.72; A(4,4)=-1.06; A(4,5)=0.39;
A(5,4)=0.48; A(5,5)=-0.72; A(5,6)=0.39;
A(6,5)=0.32; A(6,6)=-0.63; A(6,7)=0.39;
A(7,6)=0.23; A(7,7)=-0.59; A(7,8)=0.39;
A(8,7)=0.1; A(8,8)=-0.25;

B=[0.006 -0.007; 0.022 -0.027; 0.033 -0.039; 0.037 -0.039;...
        0.037 -0.029; 0.026 -0.021; 0.014 -0.011; 0 0];
C=[0.0059 0; 0.0224 0; 0.0327 0; 0.0236 0; 0 0.1961; zeros(3,2)];
D = zeros(2,8);
D(1,1) = 1;
D(2,8) = 1;


dt = 0.1;

At = expm(A*dt);
Bt = inv(A)*(expm(A*dt)-eye(8))*B;
E = 0;

[nx, dummy] = size(At);
[dummy, nu] = size(Bt);
[ny, dummy] = size(D);

Att = [At zeros(8,2); D eye(2,2)];
Btt = [Bt; zeros(2,2)];
Dtt = [D zeros(2,2)];

Qz = diag([200 20]);
Q = diag([1e5 1e4]);

P = eye(2,2);

G_opt = [-125.7204 -2.9657 2.6024 0.6125 -3.2010 -9.8755 -27.9461 -158.9449 -5.9991 -3.6828; ...
        226.1430 21.8063 5.1429 0.7936 -2.5655 -7.7096 -20.8630 -111.2584 10.2370 -2.4137];

G1 = [0 -132.1839; 373.6811 0];
G2 = [0 -1.2488; 26.0350 0];



Dy = 0;


v=[1;0.5];
us = [2; 2.5];
N = 1500;

xs = [0.04 0.1 0.21 0.38 0.57 0.76 0.89 0.95]';
x = xs;
ys = D*xs;
z = zeros(2,1);
r = [0.03; 0.96];

for i = 1:N
    if i == 600 
        r = [0.035; 0.945];
        v(1) = 1;
    end
    
    y = ys + D*(x-xs);    
    for m = 1:ny
        if y(m) < 0
            y(m) = 0;
        end
    end
    if Dy == 1
    u = G_opt(1:ny,1:nx)*((x-xs))+ G_opt(1:ny,nx+1:nx+ny)*z;
else
     u =  G1*(y - r)+ G2*z;
end
    z = z + y - r;
    
    for m = 1:nu
        if u(m) < 0
            u(m) = 0;
        end
    end
    
    f = fcol(x,u,v);
    x = x + f*dt;
    
    Y(i,:) = y';
    X(i,:) = x';
    R(i,:) = r';
    U(i,:) = u';
end

t = 0:1:N-1;

figure(1)
hold on
subplot(211)
plot(t,Y(:,1),t,R(:,1),'r'), Title('Sammenligning av regulatorer'),ylabel('y1_k'),xlabel('Diskret tid')
hold on
subplot(212)
plot(t,Y(:,2),t,R(:,2),'r'),ylabel('y2_k'),xlabel('Diskret tid')
hold on
% 
%print -depsc simulering19a
% 
% 
figure(2)
hold on
subplot(211)
plot(t,U(:,1)), Title('Sammenligning av regulatorer'),ylabel('u1_k'),xlabel('Diskret tid')
hold on
subplot(212)
plot(t,U(:,2)),ylabel('u2_k'),xlabel('Diskret tid')
hold on
% 
% 
%print -depsc simulering19b