function [G1,G2,G_sub,G_opt] = suboptimal_int(F,F1,F2,A,B,D,E,Q,Qz,P,flag,nx,nu,ny)

global R1 J_Ric fval Ric1 ex

if E == 0
    %Qt = [D(1:ny,1:nx)'*Q*D(1:ny,1:nx) zeros(nx,ny); zeros(ny,nx) Qz];
    Qt = [Q zeros(nx,ny); zeros(ny,nx) Qz];
    Pt = P;
    Nt = zeros(size(B));
else
    Qt = [D(1:ny,1:nx)'*Q*D(1:ny,1:nx) zeros(nx,ny); zeros(ny,nx) Qz];
    Pt = E'*Q*E+P;
    Nt = D'*Q*E;
end

[G_opt,Ric1] = dlqr(A,B,Qt,Pt,Nt);
G_opt = -G_opt;
J_Ric = trace(Ric1);
if ex == 0
    theta = css(G_opt,F); % theta for G_opt
elseif ex == 1
    theta = [-452 -105 -43 -1]'; % theta for wrong pairing
elseif ex == 2
    theta =[300.0000 -129.5954   24.6798   -1.2438]'; % theta for right pairing'
elseif ex == 3
    theta = [-200 250 -50 -0 -5 12 0 -1]'; % theta for multi PI-reg
end

x0 = theta;
Options = optimset('MaxFunEvals',20000,'MaxIter',20000);
[theta_asterix, fval, Exitflag, Output] = fminsearch(@theta_fun,x0,Options,F,F1,F2,A,B,D,E,Q,Qz,P,flag,nx,nu,ny);
if flag == 0
    [G1, G2] = invcss_int(theta_asterix,F1,F2);
    G_sub = 0;
elseif flag == 1
    G1 = 0;
    G2 = 0;
    G_sub = invcss(theta_asterix,F);
end


